from kivy.app import App
from kivy.uix.gridlayout import GridLayout
from kivy.uix.floatlayout import FloatLayout
from kivy.uix.button import Button
from kivy.uix.label import Label
from kivy.uix.textinput import TextInput
from kivy.graphics import Color, Rectangle
from random import randrange, randint, choice
from kivy.config import Config
from kivy.clock import Clock
Config.set('graphics', 'resizable', False)
Config.set('graphics', 'width', '800')
Config.set('graphics', 'height', '600')

P1 = (1, 9)
P2 = (0, 20)
P3 = (0, 40)
POZIOMY = {1: P1, 2: P2, 3: P3}
# declaring the colours you can use directly also
RED = [1, 0, 0, 1]
GREEN = [0, 1, 0, 1]
BLUE = [0, 0, 1, 1]
PURPLE = [1, 0, 1, 1]


def losowanie(poziom = P1):
    """funkcja pomocnicza do losowania x i y
    zwraca x, y jednocześnie co jest wygodne
    """
    print(poziom)
    x = randint(poziom[0], poziom[1])
    y = randint(poziom[0], poziom[1])
    return x, y


def rownanie(dzialanie, pierwszy_skladnik, drugi_skladnik):
    x = pierwszy_skladnik
    y = drugi_skladnik
    if dzialanie == '+':
        return x + y
    if dzialanie == '-':
        return x - y
    if dzialanie == ':':
        return int(x / y)
    if dzialanie == 'x':
        return x * y


class MainScreen(FloatLayout):

    def tekst_rownania(self):
        """ funkcja pomocnicza do zmiany tekstu równania"""
        self.dzialanie = self.losowanie_rownania()
        if self.dzialanie == ':':
            self.poziom_r = P1
            wynik = randint(1, 9)
            dzielnik = randint(1, 9)
            dzielna = wynik * dzielnik
            self.x, self.y = dzielna, dzielnik
        elif self.dzialanie == 'x' and self.poziom == P3:
            self.poziom_r = P2
            self.x, self.y = losowanie(self.poziom_r)
        else:
            self.poziom_r = self.poziom
            self.x, self.y = losowanie(self.poziom_r)
        self.text_rownania.text = str(self.x) + self.dzialanie + str(self.y) + '='

    def przypisz_dzialanie(self, instance):
        """ funkcja pomocnicza do ustawiania aktualnego działania"""
        self.dzialanie = instance.text
        self.tekst_rownania()

    def losowanie_rownania(self):
        """funkcja pomocnicza do losowania +-*/
        zwraca typ +,-,/,*
        """
        l = ['+', '-']
        l1 = ['+', '-', 'x']
        l2 = ['+', '-', 'x', ':']
        if self.poziom == P1:
            return choice(l)
        if self.poziom == P2:
            return choice(l1)
        if self.poziom == P3:
            return choice(l2)


    def ustaw_poziom(self, instance):
        """ funkcja pomocnicza do ustawiania aktualnego działania"""
        if instance.val == 1:
            self.poziom = POZIOMY[1]
            self.b1.background_normal = 'images/green_p.png'
            self.b2.background_normal = 'images/yelow.png'
            self.b3.background_normal = 'images/red.png'
        if instance.val == 2:
            self.poziom = POZIOMY[2]
            self.b1.background_normal = 'images/green.png'
            self.b2.background_normal = 'images/yellow_p.png'
            self.b3.background_normal = 'images/red.png'
        if instance.val == 3:
            self.poziom = POZIOMY[3]
            self.b1.background_normal = 'images/green.png'
            self.b2.background_normal = 'images/yelow.png'
            self.b3.background_normal = 'images/red_p.png'
        #self.x, self.y = losowanie(self.poziom)  # skoro jest ok to losujemy nowe x,y
        self.tekst_rownania()  # i zmieniamy równanie na aktualne wartości
        self.wynik.text = ''
        self.komunikat.text = ''
        self.komunikat_button.background_normal = 'images/white.png'

    def sprawdzenie_wyniku(self, instance):
        """ nasze główne obliczenia - sprawdzenie czy wynik jest ok"""
        wynik = rownanie(self.dzialanie, self.x, self.y)
        print(wynik)  # na konsoli wyświetlamy spodziewany wynik
        print(self.wynik.text)  # i wpisany wynik
        if str(wynik) == str(self.wynik.text):
            self.komunikat.text = '[color=10a337]Good :)[/color]'
            self.komunikat.markup = True
            self.x, self.y = losowanie(self.poziom)  # skoro jest ok to losujemy nowe x,y
            self.tekst_rownania()  # i zmieniamy równanie na aktualne wartości
            self.wynik.text = ''
            self.komunikat_button.background_normal = 'images/good.png'
            self.wynik.focus = True
            Clock.schedule_once(self.show_keyboard)
        else:
            self.komunikat.text = '[color=ff3333]Bad :([/color]'.format(self.wynik.text) # kolor czerwony
            self.komunikat.markup = True  # musi być ustawione by formatowanie tekstu działało
            print(self.komunikat.text)
            self.wynik.text = ''
            self.komunikat_button.background_normal = 'images/bad.png'
            self.wynik.focus = True
            Clock.schedule_once(self.show_keyboard)

    def show_keyboard(self, event):
        self.wynik.focus = True

    def __init__(self, **kwargs):
        """ init zawsze jest uruchamiany przy inicjalizacji klasy
        czyli to co jest w tej funkcji odpali się na starcie aplikacji
        """
        self.x, self.y = losowanie(P1)  # self oznacza dany obiekt czyli nasz konkretny egzemplarz klasy MainScreen
        super(MainScreen, self).__init__(**kwargs)  # super to wyzsza magia - po prostu na razie wiedz, ze tak ma być
        self.dzialanie = '+'
        self.poziom = P1
        self.poziom_r = P1

        #self.size = (800, 600)

        #white = Color(255, 255, 255)
        #back = Rectangle(size=(800, 600), source='images/rec833.png')
        with self.canvas:
            Rectangle(size=(800, 600), source='images/rec833.png')

        self.poziomy = GridLayout(cols=4, size_hint=(.9, .30), pos=(40, 400))  # tworzymy drugą siatkę z 3 kolumnami
        self.label_level = Label(text='Level:', font_size='70sp', color=(150, 150, 150, 1))
        self.b1 = Button(text='1', on_press=self.ustaw_poziom, background_normal='images/green_p.png',
                         background_down='images/green_p.png')
        self.b2 = Button(text='2', on_press=self.ustaw_poziom, background_normal='images/yelow.png',
                         background_down='images/yellow_p.png')
        self.b3 = Button(text='3', on_press=self.ustaw_poziom, background_normal='images/red.png',
                         background_down='images/red_p.png')
        self.poziomy.add_widget(self.label_level)
        self.poziomy.add_widget(self.b1)
        self.poziomy.add_widget(self.b2)
        self.poziomy.add_widget(self.b3)
        self.b1.val = 1
        self.b2.val = 2
        self.b3.val = 3
        print(self.b1.size)
        self.add_widget(self.poziomy)

        self.srodek = GridLayout(cols=2, size_hint=(.9, .30), pos=(40, 200))  # tworzymy 3'cia siatkę z 2 kolumnami

        self.text_rownania=Label(text=str(self.x)+self.dzialanie+str(self.y)+'=',
                                 font_size='70sp', color=(150, 150, 150, 1))
        self.srodek.add_widget(self.text_rownania)

        self.wynik = TextInput(multiline=False, font_size='70sp',
                               on_text_validate=self.sprawdzenie_wyniku)  # to jest pole na wpisanie wyniku
        self.srodek.add_widget(self.wynik)
        self.add_widget(self.srodek)
        Clock.schedule_once(self.show_keyboard)

        self.dol = FloatLayout( size_hint=(.9, .30), pos=(40, 20))
        self.komunikat = Label(text='', font_size='70sp', pos=(0, 40), size_hint=(.4, .7))
        self.komunikat_button = Button(text='', size_hint=(.1, .4),
                                       pos=(120, 60), background_normal='images/white.png')
        self.dol.add_widget(self.komunikat)

        #self.dol.add_widget(Button(text='?', font_size='70sp', on_press=self.sprawdzenie_wyniku))
        # to przycisk sprawdzający
        #self.b4 = Button(text='', on_press=self.sprawdzenie_wyniku, background_normal='images/question.png',
        #                 size_hint=(.3, .9), pos=(490, 20))
        self.b4 = Button(text='Check ?', on_press=self.sprawdzenie_wyniku, pos=(470, 40), size_hint=(.4, .7),
                         font_size='70sp', background_color=GREEN)
        self.dol.add_widget(self.b4)
        self.add_widget(self.dol)


class GraApp(App):

    def build(self):
        self.title = 'Math game'
        return MainScreen()  # nasza aplikacja uruchamia jedno okno z naszą główną siatką


if __name__ == '__main__':
    GraApp().run()